import { Buff } from '@cmdcode/buff';
import { SignerAPI } from '@cmdcode/signer';
import { EventEmitter } from '../class/emitter.js';
import { NostrSocket } from '../class/socket.js';
import { NostrSub } from '../class/sub.js';
import { ChannelConfig, EventFilter, EventMessage, SignedEvent, SocketConfig } from '../types.js';
export declare class NostrChannel extends EventEmitter<{
    'cancel': NostrChannel;
    'close': NostrChannel;
    'error': [error: unknown, event: SignedEvent];
    'msg': EventMessage;
    'ready': NostrChannel;
    'reject': [reason: string, event: SignedEvent];
}> {
    readonly _opt: ChannelConfig;
    readonly _signer: SignerAPI;
    _filter: EventFilter | null;
    _init: boolean;
    _secret: Buff | null;
    _socket: NostrSocket | null;
    _sub: NostrSub | null;
    constructor(signer: SignerAPI, config?: Partial<ChannelConfig>);
    get address(): string;
    get filter(): EventFilter | null;
    get id(): string;
    get pubkey(): string;
    get ready(): boolean;
    get secret(): string;
    get socket(): NostrSocket;
    get sub(): NostrSub;
    log: {
        debug: (...s: unknown[]) => void | null;
        info: (...s: unknown[]) => void | null;
    };
    _bounce_handler(reason: string, event: SignedEvent): void;
    _event_handler(event: SignedEvent): void;
    _initialize(secret: string): void;
    cancel(): this;
    close(): this;
    connect(address: string, secret: string, opt?: Partial<SocketConfig>): Promise<this>;
    on_topic<T = any>(topic: string, fn: (msg: EventMessage<T>) => void): void;
    send(subject: string, body: string): Promise<this>;
    refresh(): void;
}
