import { SignerAPI } from '@cmdcode/signer';
import { NostrChannel } from './channel.js';
import { EventEmitter } from './emitter.js';
import { NostrSocket } from './socket.js';
import { NostrStore } from './store.js';
import { EventMessage, RoomConfig } from '../types.js';
export declare class NostrRoom<T extends {}> extends EventEmitter<{
    'close': NostrRoom<T>;
    'fetch': NostrRoom<T>;
    'msg': EventMessage;
    'ready': NostrRoom<T>;
    'update': NostrRoom<T>;
}> {
    static list: (address: string, signer: SignerAPI, filter?: import("../types.js").EventFilter | undefined, options?: Partial<import("../types.js").SocketConfig> | undefined) => Promise<import("../types.js").StoreItem[]>;
    readonly _opt: RoomConfig;
    readonly _socket: NostrSocket;
    readonly _store: NostrStore<T>;
    readonly _sub: NostrChannel;
    _init: boolean;
    constructor(signer: SignerAPI, options?: Partial<RoomConfig>);
    get data(): T;
    get socket(): NostrSocket;
    get store(): Map<string, any>;
    _initialize(secret: string): void;
    _ready_check(): void;
    close(): this;
    connect(address: string, secret: string): Promise<NostrRoom<T>>;
    delete(): void;
    fetch(): Promise<NostrStore<T>>;
    init(address: string, data: T, secret: string): Promise<this>;
    on_topic<T>(topic: string, fn: (msg: EventMessage<T>) => void): void;
    refresh(): Promise<NostrStore<T>>;
    send(subject: string, body: string): Promise<NostrChannel>;
    update(data: T, tags?: string[][], updated_at?: number): Promise<NostrStore<T>>;
}
